# Xapian::Internal::RefCntBase Class Reference

Reference counted internal classes should inherit from RefCntBase. More...

`#include <base.h>`

Inheritance diagram for Xapian::Internal::RefCntBase:

[legend]
List of all members.

## Public Types

typedef unsigned int | ref_count_t

## Public Member Functions

| RefCntBase ()
| The constructor, which initialises the ref_count to 0.

## Public Attributes

ref_count_t | ref_count
| The actual reference count.

## Protected Member Functions

| RefCntBase (const RefCntBase &)
| The copy constructor.

## Detailed Description

Reference counted internal classes should inherit from RefCntBase.

This gives the object a reference count used by RefCntPtr.

## Constructor & Destructor Documentation

Xapian::Internal::RefCntBase::RefCntBase | ( | const RefCntBase & |  | ) | `[inline, protected]`

| The copy constructor. This is protected since it'll only be used by derived classes, which should only rarely need copying (this is, after all, a refcount implementation). Sometimes it's needed, though, since we need to zero ref_count in the copy.

Xapian::Internal::RefCntBase::RefCntBase | ( |  | ) | `[inline]`

| The constructor, which initialises the ref_count to 0.

## Member Data Documentation

ref_count_t Xapian::Internal::RefCntBase::ref_count`[mutable]`

| The actual reference count. It's mutable so we can have reference counting work with const pointers.

The documentation for this class was generated from the following file:

- include/xapian/base.h